package webapps.ajax1.model;

import java.sql.*;
import java.util.*;
import org.firebirdsql.jdbc.*;

/**
 * Coleccion de conexiones a b.d. firebird
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class FBCon {
    //private org.firebirdsql.pool.FBWrappingDataSource ds = new org.firebirdsql.pool.FBWrappingDataSource();
    private Driver d = null;
    private Connection c = null;
    private static List<FBCon> lst = new ArrayList<FBCon>();
    {
        try {
          Class.forName ("org.firebirdsql.jdbc.FBDriver");
          System.out.println("FBCon: FBDriver cargado!");
        } catch (java.lang.ClassNotFoundException e) {
          // A call to Class.forName() forces us to consider this exception :-)...
          System.err.println ("FBCon: Firebird JCA-JDBC driver not found in class path");
          System.err.println (e.getMessage ());
        }
    }
        
    
    /**
     * Constructor for objects of class FBCon
     */
    public FBCon(String db,String user,String pwd,String rol)
    {
        // me conecto a fb!
        try {
            
            System.out.println("FBCon: Me conecto!");
            String databaseURL = "jdbc:firebirdsql:native:"+db;
            d = java.sql.DriverManager.getDriver (databaseURL);
            System.out.println ("FBCon: Firebird JCA-JDBC driver version " +
                                d.getMajorVersion () +
                                "." +
                                d.getMinorVersion () +
                                " registered with driver manager.");
            Properties connp = new Properties();
            connp.put("user", user);
            connp.put("password", pwd);
            connp.put("role", rol);
            connp.put("lc_ctype","UTF8");
            //connp.put ("lc_ctype", "WIN1251");
            c = d.connect (databaseURL, connp);
            
            //c = java.sql.DriverManager.getConnection (databaseURL, user, password);
            
            // Set the standard properties
            // jdbc:firebirdsql://host:port//opt/firebird/db.fdb
            // jdbc:firebirdsql:native://host[:port]/<database>
            
            //String urldb = "jdbc:firebirdsql:native://localhost:3050//var/lib/firebird/3.0/data/test.fdb";
            //String urldb = "jdbc:firebirdsql://localhost:3050//var/lib/firebird/3.0/data/test.fdb";
            System.out.println("FBCon:"+databaseURL);
            //ds.setDatabase("localhost:3050//var/lib/firebird/3.0/data/test.fdb"); //urldb
            //ds.setRoleName(rol);
            //ds.setLoginTimeout(10);
            //ds.setType("type4"); // "type2" "embedded"
            //ds.setEncoding("ISO8859_1");
           
            //c = ds.getConnection(user,pwd);
            //Class.forName("org.firebirdsql.jdbc.FBDriver");
            //c = DriverManager.getConnection(urldb, "sysdba", "masterkey");

            System.out.println ("FBCon: Connection established.");
            c.setAutoCommit(false);
            System.out.println("FBCon: Auto-commit is disabled.");
            
            lst.add(this);
            
        //} catch(ClassNotFoundException nfe) {
        //        System.err.println("Clase no encontrada org.firebirdsql.jdbc.FBDriver: "+nfe.getMessage());
        } catch(java.sql.SQLException e) {
            do {
                System.err.println("FBCon: Error sql: "+e.getMessage());
                e = e.getNextException();
            } while(e != null);
            
        }
        
    }
    
    public Connection getConnection() {
        return c;
    }
    public static FBCon getFBCon(int n) {
        FBCon f = lst.get(n);
        if ( f != null ) return f;
        else return null;
    }
    public static Connection getConnection(int n) {
        FBCon f = lst.get(n);
        if ( f != null ) return f.getConnection();
        else return null;
    }
    public ResultSet getResultSet(final String query) throws SQLException {
        Statement ss = getConnection().createStatement();
        ResultSet rs = ss.executeQuery(query);
        return rs;
    }
    public int executeQuery(final String query) throws SQLException {
        return executeQuery(getConnection().createStatement(),query);
    }
    public int executeQuery(Statement st,final String query) throws SQLException {
        int n = st.executeUpdate(query);
        getConnection().commit();
        return n;
    }
    public void close(Statement ss) {
        try {
            ss.close();
        } catch(java.sql.SQLException e) {
            System.err.println("FBCon.close(Statement): Error sql: "+e.getMessage());
        }
    }
    public void close(ResultSet rs) {
        try {
            Statement ss = rs.getStatement();
            rs.close();
            ss.close();
        } catch(java.sql.SQLException e) {
            System.err.println("FBCon.close(ResultSet): Error sql: "+e.getMessage());
        }
    }
   
    public void close() {
        try {
            c.close();
            //ds.shutdown();
        } catch(java.sql.SQLException e) {
            System.err.println("FBCon.close(): Error sql: "+e.getMessage());
        }
    }
    public static void closeAll() {
        for(FBCon f : lst) f.close();
    }
    /*
     * Recibe 15/10/2020
     * Devuelve 15-OCT-2020  donde el mes de 3 digitos se expresa en ingles
     */
    public String fechaSQL(final String fechaDD_MM_YYYY) {
        System.out.println("FBCon fechaSQL("+fechaDD_MM_YYYY+") mes="+fechaDD_MM_YYYY.substring(3,5));
        int mes = new Integer(fechaDD_MM_YYYY.substring(3,5));
        String smes[] = new String[] { null, "JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC" };
        String sret = fechaDD_MM_YYYY.substring(0,2) + "-" + smes[mes] + "-" +  fechaDD_MM_YYYY.substring(6);
        return sret;
    }
}
